#ifndef INTTUPLES_H
#define INTTUPLES_H

template<unsigned int N>
struct IntTuple
{
   int i[N];

   IntTuple(int value_for_all=0)
   {
      for(unsigned int s=0; s<N; ++s)
	 i[s]=value_for_all;
   }

   IntTuple(int i0, int i1, int i2)
   {
      i[0]=i0; i[1]=i1; i[2]=i2;
   }

   IntTuple(int i0, int i1, int i2, int i3)
   {
      i[0]=i0; i[1]=i1; i[2]=i2; i[3]=i3;
   }

   IntTuple(int i0, int i1, int i2, int i3, int i4, int i5)
   {
      i[0]=i0; i[1]=i1; i[2]=i2; i[3]=i3; i[4]=i4; i[5]=i5;
   }

   bool operator==(const IntTuple<N> &other) const
   {
      for(unsigned int s=0; s<N; ++s)
	 if(i[s]!=other.i[s]) return false;
      return true;
   }
};

template<unsigned int N>
unsigned int hash(const IntTuple<N> &t)
{
   unsigned int result=t.i[0] ^ 0xd3795b3u;
   for(unsigned int s=1; s<N; ++s)
      result = (result<<5 + result) ^ t.i[s];
   return result;
}

struct Empty
{
   Empty() {}
};

#endif
